// GIT-Labor
// CWayPoint.cpp   *** Kopie aus KmgWayPoint ***

////////////////////////////////////////////////////////////////////////////////
// Header-Dateien
#include <iostream>		// Header fr die Standard-IO-Objekte (z.B. cout, cin)
#include <stdlib.h>
#include <stdio.h>
// TODO: Fgen Sie hier weitere bentigte Header-Dateien ein

using namespace std;	// Erspart den scope vor Objekte der
						// C++-Standard-Bibliothek zu schreiben
						// z.B. statt "std::cout" kann man "cout" schreiben

// Ihr eigenes h-File wird includiert
#include "CWayPoint.h"

////////////////////////////////////////////////////////////////////////////////
// Funktionen oder Klassen

string hexString( const void *pv )
{
   char buffer[12];
   snprintf( buffer, sizeof buffer, "0x%x", (unsigned int)pv );
   return string(buffer);
}


int CWayPoint::noInst = 0;  // Instanzenzaehler

CWayPoint::CWayPoint()  // GIT: Default-Konstruktor
{
   m_Name = "???";
   m_Latitude = -9999.;
   m_Longitude = -9999.;

   noInst++;
   cout << "CWayPoint<init(0)>: " << noInst << " "; print();
}

CWayPoint::CWayPoint( const CWayPoint &wp )  // GIT: Copy-Konstruktor
{
   m_Name = wp.m_Name;
   m_Text = " copy of " + hexString(&wp) + " " + wp.m_Name + wp.m_Text;
   m_Latitude  = wp.m_Latitude;
   m_Longitude = wp.m_Longitude;

   noInst++;
   cout << "CWayPoint<init(1)>: " << noInst << " "; print();
}

CWayPoint::CWayPoint( const string name, double latitude, double longitude )
{
	m_Name = name;
	m_Latitude = latitude;
	m_Longitude = longitude;

	noInst++;
	cout << "CWayPoint<init(3)>: " << noInst << " "; print();
}

CWayPoint::~CWayPoint()  // GIT: Destruktor
{
    noInst--;
    cout << "      ~CWayPoint(): " << noInst << " "; print();
}

CWayPoint& CWayPoint::operator = ( const CWayPoint &wp )  // GIT: Zuweisungsoperator
{
   if( &wp == this ) return *this;  // damit obj = obj geht

   m_Name = wp.m_Name;
   m_Text = " =  from " + hexString(&wp) + " " + wp.m_Name + wp.m_Text;
   m_Latitude  = wp.m_Latitude;
   m_Longitude = wp.m_Longitude;

   cout << "CWayPoint<operator=>: "; print();
   return *this;
}


void CWayPoint::print() const
{
	cout << "WayPoint: " << this << " " << m_Name;
	cout << " <" << m_Latitude << ", " << m_Longitude << ">" << m_Text;
	cout << endl;
}

string CWayPoint::getName() const
{
	return m_Name;
}

bool CWayPoint::eastOf( const CWayPoint & other ) const
{
	return m_Longitude > other.m_Longitude;
}

void CWayPoint::printLongitudeRelation( const CWayPoint & other ) const
{
	if( eastOf( other ) )
		cout << m_Name << " liegt oestlich von " << other.m_Name << endl;
	else
		cout << m_Name << " liegt westlich von " << other.m_Name << endl;
}

CWayPoint& CWayPoint::move( double dLat, double dLon )
{
	m_Latitude += dLat;
	m_Longitude += dLon;
	cout << "CWayPoint::move(.,.): "; print();
	return *this;
}
