// GIT-Labor
// CWayPoint.h   *** Kopie aus KmgWayPoint ***
//
// Das h-File kann auch leer bleiben, wenn es die Aufgabe nicht erfordert,
// ein h-File zu schreiben
//
// h-Files werden im Allgemeinen fr die Modularisierung von Software bentigt
// durch h-Files ist es nmlich mglich, Prototypen von Funktionen oder
// Klassendefinitionen auch in cpp-Files zu verwenden, in denen die Funktionen
// oder Klassen nicht implementiert sind
//

// das folgende Konstrukt verhindert, dass der Inhalt von
// h-Files mehrfach includiert wird
//
#ifndef CWayPoint_H
#define CWayPoint_H

#include <string>

string hexString( const void *pv );


class CWayPoint
{
public:
	CWayPoint();
	CWayPoint( const CWayPoint &wp );
	CWayPoint( string name, double latitude, double longitude );
	~CWayPoint();
	CWayPoint & operator = ( const CWayPoint &wt );

	void print() const;
	string getName() const;
	bool eastOf( const CWayPoint & other ) const;
	void printLongitudeRelation( const CWayPoint & other ) const;
	CWayPoint & move( double dLat, double dLon );

private:
	static int noInst;

	string m_Name;
	string m_Text;
	double m_Latitude;
	double m_Longitude;
};

#endif
