// GIT-Labor
// main.h

////////////////////////////////////////////////////////////////////////////////
// Header-Dateien
#include <iostream>		// Header fr die Standard-IO-Objekte (z.B. cout, cin)
#include <stdlib.h>

using namespace std;


#include "CWayPoint.h"


//         by Value       by Pointer       by Reference
//         Kopie(n byte)  Adresse(4 byte)  Aliasname (->Adresse, 4 byte)
void fkt3( CWayPoint wp,  CWayPoint *pWp,  CWayPoint &rWp )
{
   cout << "        in fkt3:  wp: "; wp.print();
   cout << "        in fkt3: pWp: "; pWp->print();   // <==> (*pWp).print()
   cout << "        in fkt3: rWp: "; rWp.print();
}

CWayPoint fkt()
{
   CWayPoint wp( "fkt", 0., 0. );
   return wp;  // by Value (should return copy, but doesn't <=> compiler optimization!?)
}

CWayPoint fkt( CWayPoint wp )
{
   cout << "    in fkt( wp ): wp: "; wp.print();
   return wp;  // by Value (returns copy of copy)
}

CWayPoint *pFkt()
{
   CWayPoint *pWp = new CWayPoint( "pFkt", 0., 0. );
   return pWp;  // by pointer (returns address)
}

CWayPoint fktFALSCH()
{
   CWayPoint *pWp = new CWayPoint( "fktFALSCH", 0., 0. );
   return *pWp;  // no way to delete pWp after return to main => memory leak
}

CWayPoint *pFktFALSCH()
{
   CWayPoint wp( "pFktFALSCH", 0., 0. );
   return &wp;  // compile-warning: address of local variable 'wp' returned => dangling reference
}

CWayPoint &rFktFALSCH()
{
   CWayPoint wp( "rFktFALSCH", 0., 0. );
   return wp;  // compile-warning: reference to local variable 'wp' returned => dangling reference
}

CWayPoint &rFktMOEGLICHaberSINNLOS( double x )
{
   CWayPoint *pWp = new CWayPoint( "rFktMOEGLICHaberSINNLOS", x, 2. );
   return *pWp;  // by reference (returns reference)
}


// Hauptprogramm
// Dient als Testrahmen, von hier aus werden die Klassen aufgerufen
int main (void)
{
// Test - Uebergabe-Parameter:

   CWayPoint wp1( "Eins", 1., 1. );
   CWayPoint wp2( "Zwei", 1., 2. );
   CWayPoint wp3( "Drei", 1., 3. );
   cout << "in main before fkt3( wp1, &wp2, wp3 );" << endl;
   fkt3( wp1, &wp2, wp3 );
   cout << "in main after return from fkt3" << endl;
   cout << endl;

   CWayPoint *pWp1 = new CWayPoint( "pEins", 2., 1. );
   CWayPoint *pWp2 = new CWayPoint( "pZwei", 2., 2. );
   CWayPoint *pWp3 = new CWayPoint( "pDrei", 2., 3. );
   cout << "in main before fkt3( *pWp1, pWp2, *pWp3 );" << endl;
   fkt3( *pWp1, pWp2, *pWp3 );
   cout << "in main after return from fkt3" << endl;
   delete pWp1;
   delete pWp2;
   delete pWp3;
   cout << endl << endl;


// Test - Rueckgabe-Wert:

   CWayPoint wp = fkt();
   cout << "in main: wp from fkt: "; wp.print();
   cout << endl;

   CWayPoint wp4( "Vier", 3., 4. );
   cout << "in main wp4 from fkt: "; wp4.print();
   wp = fkt( wp4 );
   cout << "in main: wp from fkt: "; wp.print();
   cout << endl;

   CWayPoint *pWp = pFkt();
   cout << "in main pWp from fkt: "; pWp->print();
   delete pWp;  // delete object created in pFkt
   cout << endl << endl;

   wp = fktFALSCH();  // => Memory Leak (CWaypoint object left after return from main)
   cout << "in main: wp from fktFALSCH: "; wp.print();
   cout << "      <= memory leak (no way to delete internally generated object => CWaypoint object left after return from main)" << endl;
   cout << endl;

   pWp = pFktFALSCH();  // => Dangling Reference
// cout << "in main: pWp from pFktFALSCH: "; pWp->print();  // => runtime-error
   cout << "in main: pWp from pFktFALSCH:   " << pWp << " <= dangling reference (no more valid after auto delete on return)" << endl;
   cout << endl;

   pWp = &rFktFALSCH();  // => Dangling Reference
// cout << "in main: pWp from rFktFALSCH: "; pWp->print();  // => runtime-error
   cout << "in main: pWp from rFktFALSCH:   " << pWp << " <= dangling reference (no more valid after auto delete on return)" << endl;
   cout << endl;

   pWp = &rFktMOEGLICHaberSINNLOS(1);  // store adress of returned reference in pointer variable
   cout << "in main: pWP from rFktMOEGLICHaberSINNLOS(1): "; pWp->print();
   delete pWp;  // uses pointer to delete object created in rFktMOEGLICHaberSINNLOS
   cout << endl;

   CWayPoint &rWp = rFktMOEGLICHaberSINNLOS(2);  // store returned reference
   cout << "in main: rWP from rFktMOEGLICHaberSINNLOS(2): "; rWp.print();
   delete &rWp;  // uses reference to delete object created in rFktMOEGLICHaberSINNLOS
   cout << endl << endl;


// Test - this-Pointer -> Referenz (see CWayPoint::move(.)):

   wp = wp4.move( -2., -1. ).move( -1., -3. );
   cout << "in main wp from move: "; wp.print();
   cout << endl << endl;


   cout << "\"before\" return from main" << endl;
   return 0;
}
